#! /usr/bin/perl

if (-t STDIN && @ARGV == 0) {
  print STDERR "Usage: $0 [file.off] > file.obj
Converts Geomview/OOGL \"OFF\" file into Wavefront OBJ form.
Discards colors.  Might be used as a filter, e.g.
   anytooff xyz.vect | $0 > xyz.obj
";
  exit(1);
}

while(<>) {
   s/#.*//;
   if(/[A-DF-Z]/) {
	if(!/OFF/ || $seenheader) {
	    print STDERR "$0: $ARGV doesn't look like an OFF file;
if it's in some other OOGL format, feed it to anytooff first.
";
	    exit(1);
	}
	$seenheader = 1;
        next;
   }
   @F = split(' ');
   if($nv eq "" && $F[0] =~ /^\d+$/ && @F >= 3) {
        ($nv,$nf) = @F;
   } elsif(@v < $nv && @F >= 3) {
        push(@v, join(" ", @F[0..2]));
   } elsif(@f < $nf && @F >= 1) {
	grep( $_++, @F[1..$F[0]] );
        push(@f, join(" ", @F[1..$F[0]]));
   }
}

foreach $_ (@v) {
   printf "v %s\n", $_;
}

foreach $_ (@f) {
   printf "f %s\n", $_;
}
